/* circal 0.1 (c) 2004 Peter F. Stadler */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "alitypes.h"
#include "utils.h"

#define INF 99999999

ALI *read_Data(FILE *fp) {
  int i,status,n1;
  int NN=255,nn; 
  ALI *A;
  char *line;
  
  A = (ALI *) space(sizeof(ALI)*NN);

  nn=0;    status = 0; n1=0;
  while((line=get_line(fp))!=NULL) {
    /* printf(" >> %s\n",line);fflush(stdout); */
    if(line[0]=='>') {
      char X[100], Y[100], Z[100], ZZ[200];
      { /* get rid of microsoft ^M characters */
	int kkk,lll;
	lll = strlen(line);
	for(kkk=0;kkk<lll;kkk++) {
	  if( ((int)line[kkk]<32)&&((int)line[kkk]>0) ) { line[kkk]=' '; }
	}
      }
      status = 1;
      n1=64;
      A[nn].N=1;
      A[nn].s = (char ***) space(sizeof(char**)*1);
      A[nn].s[0] = (char **) space(sizeof(char*)*n1);
      A[nn].names = (char **) space(sizeof(char*)*1);
      A[nn].ID = (char **) space(sizeof(char*)*1);
      X[0] = '\0'; Y[0] = '\0'; Z[0] = '\0';
      sscanf(line,"> %99s %99s %99s  ",X,Y,Z);
      ZZ[0]='\0';
      strcat(ZZ,Y); strcat(ZZ,"_"); strcat(ZZ,Z);
      A[nn].ID[0]    = strdup(X);
      A[nn].names[0] = strdup(ZZ);
      /* printf("%d %s <%s>\n",nn,A[nn].ID[0],A[nn].names[0]); */ 
      nn++;
      if(nn>=NN) { NN*=2; A = (ALI*) xrealloc(A,sizeof(ALI)*NN); }
    }
    else if(line[0]=='#') {;}
    else if(status==1) {
      char *tok,*ll; int ii;
      ll = line;
      tok = strtok(ll," ");
      ii=1;
      while(tok) {
	/* printf(" ??? %d %s\n",ii,tok); */
	if(ii>=n1) {
	  n1*=2;
	  A[nn-1].s[0] = (char **) xrealloc(A[nn].s[0],sizeof(char*)*n1);
	}
	A[nn-1].s[0][ii] = strdup(tok);
	ii++;
	A[nn-1].L = ii-1;
	tok = strtok(NULL," ");
      }
    }
    free(line);
  }
  for(i=0;i<nn;i++) A[i].del  = (int *) space(sizeof(int)*(A[i].L+1));
  for(i=0;i<nn;i++) A[i].x    = (int *) space(sizeof(int)*(A[i].L+1));
  for(i=0;i<nn;i++) A[i].type = (char *) space(sizeof(char)*(A[i].L+1));
  A[nn].N=-1;
  return A;
}


void print_alignment(const ALI *A) {
  int i,j;
  printf("# ** %d Sequences of length %d\n",A->N,A->L);
  for(i=0;i<A->N;i++) {
    printf("'%-12s'   ",A->ID[i]);
    printf("<%-30s>   ",A->names[i]);
    for(j=1;j<=A->L;j++) {
      if(A->s[i][j]==NULL) { printf(" -==- "); } 
      else { printf("%5s ",A->s[i][j]); }
    }
    printf("\n");
    /*
    printf("'            '   <                              >   ",A->ID[i]);
    for(j=1;j<=A->L;j++) printf("%5d ",A->del[j]);
    printf("\n");
    */
    fflush(stdout);
  }
  /*
  printf("'%-12s'   "," " ); printf("<%-30s>   "," ");
  for(j=1;j<=A->L;j++) printf(" (%2d) ",A->x[j]);
  printf("\n");
  */
}


void HAU_WECH(ALI *M,char *fn) {
 
  int p,q;
  FILE *fp;
  fp = fopen(fn,"w");

  fprintf(fp,
	  "%%!PS-Adobe-2.0 EPSF-1.2\n"
	  "%%%%BoundingBox:  28 46 564 527\n"
	  "/BACKGROUND { 0.25 } def\n"
	  "/COLOR-x    { 0.0 1.0 0.0 setrgbcolor } def\n"
	  "/COLOR-t    { 1.0 0.9 0.3 setrgbcolor } def\n"
	  "/COLOR-P    { 1.0 0.0 0.0 setrgbcolor } def\n"
	  "/COLOR-R    { 1.0 0.4 0.2 setrgbcolor } def\n"
	  "/usenames   { true } def\n"
	  "/xoffset    { 0.6 } def\n" 
	  "/yoffset    { 0.6 } def\n"
	  "/deffont { /Helvetica findfont 0.85 scalefont setfont } def\n" 
	  "/xstart  {  1 } def \n"
	  "/ystart  {  0 } def \n"
	  "/xstop   { %d } def \n"
	  "/ystop   { %d } def \n",M->L, M->N-1);
  fprintf(fp, 
	  "/tmp 12 string def  \n"
	  "/max { dup 3 2 roll dup 3 1 roll lt { exch } if pop } def \n"
	  "/rectangle {%% x y width height rectangle \n"
	  "/hh exch def \n"
	  "/ww exch def \n"
	  "newpath \n" 
	  "ystop exch sub \n"
	  "moveto \n"
	  "ww 0.5 mul neg hh 0.5 mul neg rmoveto \n"
	  "ww 0 rlineto 0 hh rlineto ww neg 0 rlineto \n"
	  "closepath fill stroke \n" 
	  "} bind def\n" 
	  "/centershow {\n" 
	  "  gsave \n" 
	  "  dup stringwidth pop 2 div neg 0 rmoveto\n" 
	  "  show\n" 
	  "  grestore\n" 
	  "} bind def\n" 
	  "/rightshow {\n" 
	  "      gsave \n" 
	  "  dup stringwidth pop neg 0 rmoveto\n" 
	  "  show\n" 
	  "  grestore\n" 
	  "} bind def\n" );
  fprintf(fp,   	  
	  "/drawoutline {	\n" 
	  "  newpath	 \n"     
	  "  xstart xoffset sub ystart yoffset sub ystop exch sub  moveto \n" 
	  "  xstart xoffset sub ystop yoffset add ystop exch sub lineto\n" 
	  "  xstop  xoffset add ystop yoffset add ystop exch sub lineto\n" 
	  "  xstop  xoffset add ystart yoffset sub ystop exch sub lineto\n" 
	  "  closepath BACKGROUND setgray fill\n" 
	  "  stroke\n");
  fprintf(fp, 
	  "0.0 setgray\n"
	  "  xstart 1 sub ystop 0.2 sub moveto\n"
	  "  usenames\n"
	  "    { Names { gsave  rightshow grestore 0 -1 rmoveto } forall }\n"
	  "    { ID { gsave  rightshow grestore 0 -1 rmoveto } forall }\n"
	  "  ifelse\n"
	  "  xstart 0.4 sub ystop 1 add moveto\n" 
	  "  What  { gsave  270 rotate rightshow grestore 1 0 rmoveto } forall\n"
	  "} bind def\n");
  fprintf(fp,
	  "/x { 1.1  1.1   COLOR-x rectangle 0 0 0 setrgbcolor } bind def\n"
	  "/P { 0.97 0.97  COLOR-P rectangle 0 0 0 setrgbcolor } bind def\n" 
	  "/t { 0.97 0.97  COLOR-t rectangle 0 0 0 setrgbcolor } bind def\n" 
	  "/R { 0.97 0.97  COLOR-R rectangle 0 0 0 setrgbcolor } bind def\n" 
	  "/width  { xstop xstart sub } bind def\n" 
	  "/height { ystop ystart sub } bind def\n" 
	  "width height max /len exch def\n" );
  fprintf(fp,   	  
	  "gsave \n" 
	  "72 72 translate\n" 
	  "72 6 mul len div  dup scale\n"
	  "deffont\n"
	  "0.05 setlinewidth\n" 
	  "gsave \n" 
		  );
  fprintf(fp,"/ID [\n");
  for(p=0;p<M->N;p++) fprintf(fp,"   (%s)\n",M->ID[p]);
  fprintf(fp,"] def\n");

    fprintf(fp,"/Names [\n");
  for(p=0;p<M->N;p++) fprintf(fp,"   (%s)\n",M->names[p]);
  fprintf(fp,"] def\n");
  
  fprintf(fp,"/What [\n");
  for(q=1;q<=M->L;q++) {
    for(p=0;p<M->N;p++) {
      if(strcmp(M->s[p][q],"_____")!=0) {
	fprintf(fp,"   (%s)\n",M->s[p][q]);
	p=M->N;
      }
    }
  }
  fprintf(fp,"] def\n");
  fprintf(fp,"\ndrawoutline\n");

  for(p=0;p<M->N;p++) {
    for(q=1;q<=M->L;q++) {
      if(strcmp(M->s[p][q],"_____")!=0) {
	fprintf(fp,"  %2d %2d %c\n",q,p,M->type[q]);
      }
    }
  }
  
  fprintf(fp,"grestore\ngrestore\nshowpage\n");
  fclose(fp);

}

void dump_NEX(const ALI *M, char *fn) {
  int p,q;
  char c;
  FILE *fp;
  fp = fopen(fn,"w");
  fprintf(fp,
	  "#NEXUS\nBEGIN taxa;\n"
	  "   DIMENSIONS ntax=%d;\n"
	  "TAXLABELS\n",M->N);
  for(p=0;p<M->N;p++)  fprintf(fp,"[%d] %s\n",p+1,M->ID[p]);
  fprintf(fp,
	  ";\nEND;\n"
	  "BEGIN characters;\n"
	  "   DIMENSIONS nchar = %d;\n",M->L);
  fprintf(fp,
	  "   FORMAT\n"
	  "      no labels\n"
	  "      symbols = \"0 1\"\n"
	  "   ;\n"
	  "   MATRIX\n");
  for(p=0;p<M->N;p++) {
    fprintf(fp," ");
    for(q=1;q<=M->L;q++) {
      if(strcmp(M->s[p][q],"_____")==0) c='0';
      else c='1';
      fprintf(fp,"%c",c);
    }
    fprintf(fp,"\n");
  }
  fprintf(fp,"[");
  for(q=1;q<=M->L;q++) fprintf(fp,"%c",M->type[q]); fprintf(fp," types]\n");
  {
    int qq;
    for(qq=0;qq<5;qq++) {
      fprintf(fp,"[");
      for(q=1;q<=M->L;q++) {
	int kk;
	kk=0;
	for(p=0;p<M->N;p++) { 
	  if( (kk==0)&&(strcmp(M->s[p][q],"_____")!=0) ) {
	    kk=1;
	    if(M->s[p][q][0]=='-') { 
	      if(qq<strlen(M->s[p][q])) fprintf(fp,"%c",M->s[p][q][qq]);
	      else fprintf(fp," ");
	    }
	    else { 
	      if(qq==0) fprintf(fp," ");
	      else {
		if(qq<=strlen(M->s[p][q]))
		  fprintf(fp,"%c",M->s[p][q][qq-1]);
		else
		  fprintf(fp," ");
	      }
	    }
	  }
	}
      }
      fprintf(fp,"]\n");
      }
  }
  
  fprintf(fp,";\nEND;");
  fclose(fp);
}
