#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "utils.h"


int main(int argc, char*argv[]) {
  char *line,*tmp;
  char **X, **Y, **Z;
  char **taxon;
  int i,j,n,k,l,N,status,ti,NN;
  int xbegin, xend;
  FILE *fp;

  line = get_line(stdin);
  status = 0;
  X = NULL;
  k=0; l=0;
  X = (char **) space(sizeof(char *)*(1000));
  Y = (char **) space(sizeof(char *)*(10));
  taxon = (char **) space(sizeof(char *)*(1000));

  status = 0;
  ti=0;
  if(argc<3) exit(2);
  
  xbegin = atoi(argv[1]);
  if(xbegin<1) xbegin=1;
  xend   = atoi(argv[2]);
  
  while(line) {
    tmp = (char *) space(sizeof(char)*(strlen(line)+1));
    sscanf(line,"%s",tmp);
    if(strcmp(tmp,";")==0) status = 0;
    if((status==1)&&(line[0]!='[')){
      /* printf("^%s^\n",tmp); */
      X[k] = strdup(tmp); k++;
    }
    if((status==1)&&(line[0]=='[')){
      Y[l] = strdup(line+1); l++;
    }
    if((status==2)&&(line[0]=='[')){
      int ii;
      sscanf(line,"[%d] %s",&ii,tmp);
      if(ii!=ti+1) printf("Do hods wos!\n");
      taxon[ti]=strdup(tmp);
      ti++;
    }
    if(strcmp(tmp,"MATRIX")==0) status =1;
    if(strcmp(tmp,"TAXLABELS")==0) status =2;

    free(line); free(tmp);
    line = get_line(stdin);
  }
  n=k;
  printf("%d\n",k);
  if(xend>n) xend=n;

 
  for(k=xbegin-1;k<xend;k++) {
    printf("%3d %s\n",k+1,X[k]);
  }

  N = strlen(Y[0]);
  Z = (char **) space(sizeof(char*)*(N+1));
  for(k=0;k<N;k++) Z[k] = (char *) space(sizeof(char)*11);
   
  for(k=0;k<N;k++) {
    for(i=0;i<l;i++) {
      if(Y[i][k]!=' ') Z[k][i]=Y[i][k];
      else {
	if (i==1) Z[k][i]='+';
	else      Z[k][i]='\0';
      }
    }
  }

  for(i=0;i<N;i++) {
    int i1, c1;
    if((Z[i][0]!='*')&&(Z[i][0]!='#')) {
      i1=i; c1=0;
      for(k=i;k<N;k++) {
	if((Z[k][0]!='*')&&(Z[k][0]!='#')) {
	  if(strcmp( Z[i]+2,Z[k]+2 )==0) {
	    int j,c2;
	    c2=0;
	    for(j=xbegin-1;j<xend;j++) {
	      if(X[j][k]=='1') c2 ++;
	    }
	    if(c2>c1) { c1=c2; i1=k; }
	    Z[k][0]='*';
	  }
	}
      }
      if(c1>0) Z[i1][0]='#';	
    }
  }
 
  printf("> consensus of lines %d through %d\n",xbegin,xend);
  
  for(i=0;i<N;i++) {
    if(Z[i][0]=='#') {
      if(Z[i][1] == '+') printf("%s ", Z[i]+2);
      if(Z[i][1] == '-') printf("%s ", Z[i]+1);
    }
  }
  printf("\n");

  NN=0; for(i=0;i<N;i++) { if(Z[i][0]=='#') NN++; }


  fp = fopen("parsi.phylip","w");
  fprintf(fp,"%d %d\n",n,NN);
  for(i=0;i<n;i++) { 
    fprintf(fp,"%-10s ",taxon[i]);

    for(j=0;j<N;j++) {
      int j1,j2,kk;
      char ccc;
      j2=-1;
      
      if(Z[j][0]=='#') {
	kk=0;
	for(j1=0;j1<N;j1++) {
	  if(strcmp( Z[j1]+2,Z[j]+2 )==0) {
	    if(X[i][j1]=='1') j2=kk;
	    kk++;
	  }
	}
	if(j2<0) ccc = '-';
	else ccc = (char) 65+j2;
	fprintf(fp,"%c",ccc);
      }
    }
    fprintf(fp,"\n");
  }
  fprintf(fp,"\n");


  fprintf(fp,"Condensed columns, gene, direction, and original columns:\n");
  fprintf(fp,"No. O Gene   Columns in Alignment file\n");
  for(j=0;j<N;j++) {
    int j1;
    if(Z[j][0]=='#') {
      fprintf(fp,"%3d %c %-6s ",j+1,Z[j][1],Z[j]+2);
      for(j1=0;j1<N;j1++) {
	if(strcmp( Z[j1]+2,Z[j]+2 )==0) {
	  fprintf(fp,"%c%d ",Z[j1][1],j1+1);
	}
      }
      fprintf(fp,"\n");
    }
  }
  fprintf(fp,"\n");
  
  fclose(fp);

  

  
  return 0;
}
